/*
 *
 *	sowam_c
 *		Bytecode-Interpreter fuer die SOWAM
 *
 *
 *	FILE
 *		af-area.h
 *
 *	PURPOSE
 *		Verwaltung der Atom/Funktor-Area
 *
 *
 *	AUTHORS
 *		Andreas Schwab
 *
 *
 */

/* Indices der eingebauten Symbole */

#define NIL		0
#define SUCC_SYM	(1|0x10000)
#define ZERO_SYM	2
#define READERROR_SYM	3
#define EQ_SYM		(4|0x20000)
#define COMP_SYM	(5|0x20000)
#define CONST_SYM	(6|0x10000)
#define VAR_SYM		(7|0x10000)
#define STR_SYM		(8|0x10000)
#define LIST_SYM	(9|0x20000)
#define INT_SYM		(10|0x10000)
#define YFX_SYM		(11|0x20000) 
#define XFY_SYM		(12|0x20000)
#define XFX_SYM		(13|0x20000)
#define FY_SYM		(14|0x20000)
#define YF_SYM		(15|0x20000)
#define EOF_SYM		16
#define INPUT_SYM	17
#define OUTPUT_SYM	18
#define APPEND_SYM	19

int	lookup_symbol PROTO((char *name, int arity));
void	init_builtin_symbols PROTO((void));
