/*
 * plread.h
 *   Header file for use of "plread.c", a general Prolog expression parser.
 *   Just a few constant #define's for your 'get_operator_type' function
 *   and the only exported interface function.
 *
 * Copyright (C) 1990 V.Siebert
 */

#ifndef __PLREAD_H
#define __PLREAD_H

#define OP_FX		0x01
#define OP_FY		0x02
#define OP_PREFIX	0x03

#define OP_XF		0x04
#define OP_YF		0x08
#define OP_POSTFIX	0x0c

#define OP_XFX		0x10
#define OP_XFY		0x20
#define OP_YFX		0x40
#define OP_INFIX	0x70

#define OP_LEFTASSOC	0x48
#define OP_RIGHTASSOC	0x22

#define OP_ATOM		0x80

#if __STDC__
extern int prolog_read (TERM *result);
#else
extern int prolog_read ();
#endif

#endif	/* __PLREAD_H */
